unit Artikel_text_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, ActnList,
  Menus, Buttons, Grids, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    actClose: TAction;
    actSucheSpeichern: TAction;
    actSuche: TAction;
    actSaveCSVfile: TAction;
    actLoadTextFile: TAction;
    ActionList1: TActionList;
    btnSuche: TBitBtn;
    btnSaveCSVfile: TBitBtn;
    btnClose: TBitBtn;
    btnLoadTextFile: TBitBtn;
    edSuche: TEdit;
    gbSuche: TGroupBox;
    gridSuche: TStringGrid;
    MainMenu1: TMainMenu;
    mnSucheSpeichern: TMenuItem;
    mnSuchen: TMenuItem;
    mnSuche: TMenuItem;
    mnClose: TMenuItem;
    Separator1: TMenuItem;
    mnSaveCSVfile: TMenuItem;
    mnLoadtextFile: TMenuItem;
    mnDatei: TMenuItem;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    SaveDialog1: TSaveDialog;
    gridArtikel: TStringGrid;
    procedure actCloseExecute(Sender: TObject);
    procedure actLoadTextFileExecute(Sender: TObject);
    procedure actSaveCSVfileExecute(Sender: TObject);
    procedure actSucheExecute(Sender: TObject);
    procedure actSucheSpeichernExecute(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

const
  textseparator='|';              // ggf anpassen
  csvseparator=';';               // ggf anpassen
  headerID='ID';                  // Annahme, dass die Überschrift so beginnt
  csvext='.csv';

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.actLoadTextFileExecute(Sender: TObject);
var
  textlist, splitlist: TStringList;
  i, k: integer;

begin
  OpenDialog1.Title:='Lade Textdate...';
  if OpenDialog1.Execute then begin
    Screen.Cursor:=crHourGlass;
    textlist:=TStringList.Create;
    splitlist:=TStringList.Create;
    splitlist.StrictDelimiter:=true;
    splitlist.Delimiter:=textseparator;
    gridArtikel.Rowcount:=1;
    gridArtikel.Colcount:=1;
    textlist.LoadFromFile(OpenDialog1.FileName);
    gridArtikel.BeginUpdate;
    try
      for i:=0 to textlist.Count-1 do begin
        splitlist.DelimitedText:=textlist[i];
        if gridArtikel.ColCount<splitlist.Count then
          gridArtikel.ColCount:=splitlist.Count-1;
        if splitList.Count>1 then begin                     // Leerzeilen und trenner ignorieren
          if trim(splitlist[1])=headerID then begin
            for k:=1 to splitlist.Count-2 do
              gridArtikel.Cells[k-1, 0]:=trim(splitlist[k]);
          end else begin
            gridArtikel.Rowcount:=gridArtikel.Rowcount+1;  // neue Zeile
            for k:=1 to splitlist.Count-2 do
              gridArtikel.Cells[k-1, gridArtikel.Rowcount-1]:=trim(splitlist[k]);
          end;
        end;
      end;
      gridArtikel.AutoSizeColumns;
    finally
      gridArtikel.EndUpdate;
      splitlist.Free;
      textlist.Free;
      screen.Cursor:=crDefault;
    end;
  end;
end;

procedure TForm1.actSaveCSVfileExecute(Sender: TObject);
begin
  SaveDialog1.Title:='Artikel als CSV speichern...';
  SaveDialog1.FileName:=ChangeFileExt(OpenDialog1.FileName,csvext);   // Vorschlag
  if SaveDialog1.Execute then begin
    gridArtikel.SaveToCSVFile(SaveDialog1.Filename, csvseparator);
  end;
end;

procedure TForm1.actSucheExecute(Sender: TObject);
var
  i, k, p: integer;

begin
  gridSuche.Colcount:=gridArtikel.ColCount;
  for i:=1 to gridArtikel.RowCount-1 do begin
    for k:=0 to gridArtikel.ColCount-1 do begin
      if pos(edSuche.Text, gridArtikel.Cells[k, i])>0 then begin
        gridArtikel.SetFocus;                 // zur gefundenen Zeile springen
        gridArtikel.Col:=k;
        gridArtikel.Row:=i;
        for p:=0 to gridArtikel.ColCount-1 do begin
          gridSuche.Cells[p, 0]:=gridArtikel.Cells[p, i];

        end;
        exit;
      end;
    end;
  end;

  gridSuche.AutoSizeColumns;
end;

procedure TForm1.actSucheSpeichernExecute(Sender: TObject);    // kann man verbessern oder etwas spezielles machen, z.B.Zwischenablage
begin
  gridSuche.SaveToCSVFile(ChangeFileExt(OpenDialog1.FileName, '')+'_Suchtreffer'+csvext);
end;

procedure TForm1.actCloseExecute(Sender: TObject);
begin
  Close;
end;

end.

